#include "effect_single_dynamic.h"
#include "functions.h"

SingleDynamicEffect::SingleDynamicEffect() {
  for (int i=0; i<tile_count; i++) tiles[i] = CHSV(random8(), 180, 255);
}
int SingleDynamicEffect::getLoopTime() {
    return EFFECT_SINGLE_DYNAMIC_LOOP_TIME;
}
void SingleDynamicEffect::update() {
  tiles[random8(tile_count)] = CHSV(random8(), 180, 255);
}
boolean SingleDynamicEffect::can_be_shown_with_clock() { return true; }
void SingleDynamicEffect::loop() {
  EVERY_N_MILLISECONDS(getLoopTime()) {
    memcpy(old_tiles, tiles, tile_count*sizeof(CRGB));
    blend = 0;
    update();
  }

  for (int x=0; x<window.w; x++) for (int y=0; y<window.h; y++) {
    int index = y/2 * window.w/2 + x/2;
    setPixel(window, x, y, nblend(old_tiles[index], tiles[index], blend));
  }
  if (blend < 255) blend+=20;
}
